import tkinter as tk
from tkinter import ttk
import os

root = tk.Tk()
root.title('Printer Config')
root.geometry('600x200')

#Configure Grid
root.columnconfigure(0,weight=2)
root.columnconfigure(1,weight=1)
root.columnconfigure(2,weight=1)
root.columnconfigure(3,weight=1)
root.columnconfigure(4,weight=1)

#Variables
sheets_data_file="SheetsData.dat"
types_data_file="TypesData.dat"
colors_data_file="ColorsData.dat"
nozzles_data_file="NozzlesData.dat"
enclosure_data_file="EnclosureData.dat"
current_config_file="CurrentConfig.dat"
cc_sheet=''
cc_type=''
cc_color=''
cc_nozzle=''
cc_enclosure=''

#Functions
def callback_sheet(event):
     global cc_sheet
     cc_sheet = sheet_combobox.get()
     button_color_red()

def callback_type(event):
     global cc_type
     cc_type= type_combobox.get()
     button_color_red()
     
def callback_color(event):
     global cc_color
     cc_color= color_combobox.get()
     button_color_red()

def callback_nozzle(event):
     global cc_nozzle
     cc_nozzle= nozzle_combobox.get()
     button_color_red()

def callback_enclosure(event):
     global cc_enclosure
     cc_enclosure= enclosure_combobox.get()
     button_color_red()
    
def button_clicked():
    global cc_list
    os.remove('CurrentConfig.dat')
    output_file=open('CurrentConfig.dat','w')
    output_file.writelines(cc_sheet)
    output_file.writelines(cc_type)
    output_file.writelines(cc_color)
    output_file.writelines(cc_nozzle)
    output_file.writelines(cc_enclosure)
    output_file.close()
    button_color_gray()

def button_color_red():
    btn_save.configure(bg='#EE0000',fg='#EEEE00')

def button_color_gray():
    btn_save.configure(bg='#F0F0F8',fg='#000000')
    
#Make Labels
##title
lbl_title=ttk.Label(root,text='CURRENT CONFIG')
lbl_title.grid(column=2,row=0)
##sheets
lbl_sheet=ttk.Label(root,text='Sheet')
lbl_sheet.grid(column=0,row=1)
##types
lbl_type=ttk.Label(root,text='Type')
lbl_type.grid(column=1,row=1)
##colors
lbl_color=ttk.Label(root,text='Color')
lbl_color.grid(column=2,row=1)
##nozzles
lbl_nozzle=ttk.Label(root,text='Nozzle')
lbl_nozzle.grid(column=3,row=1)
##enclosure
lbl_enclosure=ttk.Label(root,text='Enclosure')
lbl_enclosure.grid(column=4,row=1)

#get current configuration
input_file=open(current_config_file,'r')
cc_sheet=input_file.readline()
cc_type=input_file.readline()
cc_color=input_file.readline()
cc_nozzle=input_file.readline()
cc_enclosure=input_file.readline()
input_file.close()

#Make and fill comboboxes
##Sheets
sheet_combobox=ttk.Combobox(root,width=14,height=6,state='readonly')
input_file=open(sheets_data_file,'r')
items=['']
for item in input_file:
    items.append(item)
sheet_combobox['values']=items
input_file.close()
sheet_combobox.grid(column=0,row=3)
sheet_combobox.set(cc_sheet)
sheet_combobox.bind("<<ComboboxSelected>>",callback_sheet)

##Types
type_combobox=ttk.Combobox(root,width=14,height=6,state='readonly')
input_file=open(types_data_file,'r')
items=['']
for item in input_file:
    items.append(item)
type_combobox['values']=items
input_file.close()
type_combobox.grid(column=1,row=3)
type_combobox.set(cc_type)
type_combobox.bind("<<ComboboxSelected>>",callback_type)

##Colors
color_combobox=ttk.Combobox(root,width=14,height=6,state='readonly')
input_file=open(colors_data_file,'r')
items=['']
for item in input_file:
    items.append(item)
color_combobox['values']=items
input_file.close()
color_combobox.grid(column=2,row=3)
color_combobox.set(cc_color)
color_combobox.bind("<<ComboboxSelected>>",callback_color)

##Nozzles
nozzle_combobox=ttk.Combobox(root,width=14,height=6,state='readonly')
input_file=open(nozzles_data_file,'r')
items=['']
for item in input_file:
    items.append(item)
nozzle_combobox['values']=items
input_file.close()
nozzle_combobox.grid(column=3,row=3)
nozzle_combobox.set(cc_nozzle)
nozzle_combobox.bind("<<ComboboxSelected>>",callback_nozzle)

##Enclosure
enclosure_combobox=ttk.Combobox(root,width=14,height=6,state='readonly')
input_file=open(enclosure_data_file,'r')
items=['']
for item in input_file:
    items.append(item)
enclosure_combobox['values']=items
input_file.close()
enclosure_combobox.grid(column=4,row=3)
enclosure_combobox.set(cc_enclosure)
enclosure_combobox.bind("<<ComboboxSelected>>",callback_enclosure)

#Make Save Button
btn_save=tk.Button(root,text='Save',bg='#F0F0F8',fg='#000000',command=button_clicked)
btn_save.grid(column=4,row=0)

root.mainloop()
